import javax.swing.*;
import java.io.*;


import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.*;


public class ProjectFrame extends JFrame{
	DrawingPanel panel;
	ArrayList<Point> points = (ArrayList<Point>)new ArrayList<Point>();

	public ProjectFrame(String title){
		super(title);
		panel = new DrawingPanel(points);
		add(panel); // component added 
		createMenubar();
		
		setSize(new Dimension(600,800));
		setLocation(400,100);	
	}
	
	public void createMenubar(){
	    JMenuBar menubar = new JMenuBar();

	    JMenu fileM = new JMenu("File");
	    fileM.setMnemonic(KeyEvent.VK_F);

	    // Clear menu item
	    JMenuItem clearMI = new JMenuItem("Clear");
	    clearMI.setMnemonic(KeyEvent.VK_L);
	    clearMI.setToolTipText("Save input");
	    clearMI.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event){
	            // clear input
	    		points.clear();
	    		repaint();
	    	}
	    });
	    fileM.add(clearMI);

	    // Load menu item
	    JMenuItem loadMI = new JMenuItem("Load");
	    loadMI.setMnemonic(KeyEvent.VK_L);
	    loadMI.setToolTipText("Save input");
	    loadMI.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event){
	            // load input
	    		
	    		String filename;
	    		System.out.print("Please enter name for graph file: ");	
	    		Scanner scanner = new Scanner(System.in);
	    		filename = scanner.nextLine();

	    	    try{
	    	        scanner = new Scanner(new File(filename));  	        
	    	    	int x, y, n=0;
	    	    	
	    	    	while(scanner.hasNext()){
	    	    		// New point
	    	    		x = (int)scanner.nextDouble();
	    	    		y = (int)scanner.nextDouble();
	    	    		n++;
	    	    		System.out.println("Point "+x+","+y);
	    	    		points.add(new Point(x,y));
	    	    	} // while	
	    	    } catch(FileNotFoundException e){
	    	        System.err.println("Could not find file "+filename+". "+e);
	    	        System.exit(0);
	    	    } catch(IOException e){
	    	        System.err.println("Error reading integer from file "+filename+". "+e);
	    	        System.exit(0);
	    	    }	   
	    	    repaint();
	        }
	    });
	    fileM.add(loadMI);
	    
	    
	    // Save menu item
	    JMenuItem saveMI = new JMenuItem("Save");
	    saveMI.setMnemonic(KeyEvent.VK_S);
	    saveMI.setToolTipText("Save input");
	    saveMI.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event){
	            // save input
	    		
	    		String filename;
	    		System.out.print("Please enter name to save graph file: ");	
	    		Scanner scanner = new Scanner(System.in);
	    		filename = scanner.nextLine();

	    	    try{
	    	    	PrintWriter writer = new PrintWriter(filename);
	    	    	for(int i=0; i<points.size(); i++){
	    	    		Point point = points.get(i);
	    	    		writer.print(point.getX());
	    	    		writer.print(" ");
	    	    		writer.println(point.getY());
	    	    	}
	    	    	writer.close();
	    	    } catch(FileNotFoundException e){
	    	        System.err.println("Could not find file "+filename+". "+e);
	    	        System.exit(0);
	    	    } catch(IOException e){
	    	        System.err.println("Error reading integer from file "+filename+". "+e);
	    	        System.exit(0);
	    	    }	   
	        }
	    });
	    fileM.add(saveMI);
	    
	    // Exit menu item
	    JMenuItem exitMI = new JMenuItem("Exit");
	    exitMI.setMnemonic(KeyEvent.VK_E);
	    exitMI.setToolTipText("Exit application");
	    exitMI.addActionListener(new ActionListener(){
	    	public void actionPerformed(ActionEvent event){
	                System.exit(0);
	        }
	    });
	    fileM.add(exitMI);
	    
    
	    menubar.add(fileM);
	    setJMenuBar(menubar);
		
	}

	
	public static void main(String[] args) {
		ProjectFrame frame = new ProjectFrame("Project Frame"); 
	    frame.setVisible(true); // displays the frame
   }
}
